var iwetcWpEditorBaseSettings = {
    mediaButtons: false,
    direction: 'ltr',
    tinymce: {
        height: '200',
        branding: false,
        theme: 'modern',
        skin: 'lightgray',
        language: 'en',
        formats: {
            alignleft: [
                { selector: 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li', styles: { textAlign: 'left' } },
                { selector: 'img,table,dl.wp-caption', classes: 'alignleft' }
            ],
            aligncenter: [
                { selector: 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li', styles: { textAlign: 'center' } },
                { selector: 'img,table,dl.wp-caption', classes: 'aligncenter' }
            ],
            alignright: [
                { selector: 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li', styles: { textAlign: 'right' } },
                { selector: 'img,table,dl.wp-caption', classes: 'alignright' }
            ],
            strikethrough: { inline: 'del' }
        },
        relative_urls: false,
        remove_script_host: false,
        convert_urls: false,
        browser_spellcheck: true,
        fix_list_elements: true,
        entities: '38,amp,60,lt,62,gt',
        entity_encoding: 'raw',
        keep_styles: false,
        paste_webkit_styles: 'font-weight font-style color',
        preview_styles: 'font-family font-size font-weight font-style text-decoration text-transform',
        end_container_on_empty_block: true,
        wpeditimage_disable_captions: false,
        wpeditimage_html5_captions: true,
        plugins: 'charmap,colorpicker,hr,lists,paste,textcolor,fullscreen,wordpress,wpautoresize,wpemoji,wplink,wpdialogs,wptextpattern,wpview',
        fontsize_formats: "10px 11px 12px 13px 14px 15px 16px 17px 18px 19px 20px 21px 22px 23px 24px 26px 28px 30px 36px",
        menubar: true,
        wpautop: true,
        indent: false,
        resize: true,
        theme_advanced_resizing: true,
        theme_advanced_resize_horizontal: false,
        statusbar: true,
        toolbar1: 'formatselect,fontsizeselect,bold,italic,bullist,numlist,blockquote,alignleft,aligncenter,alignright,link,unlink,wp_adv',
        toolbar2: 'strikethrough,hr,forecolor,pastetext,removeformat,charmap,outdent,indent,undo,redo,wp_help',
        toolbar3: 'shortcode',
        toolbar4: '',
        tabfocus_elements: ':prev,:next',
        setup: ''
    },
    quicktags: true
}

var iwetcBuilderEditorSettings = iwetcWpEditorBaseSettings;
var iwetcCouponTextEditorSettings = iwetcWpEditorBaseSettings;
var needToConfirm = false;

function iwetcTextEditorShortcodes(editor) {
    return [
        {
            text: 'Generals',
            menu: [
                {
                    text: 'Admin email',
                    onclick: function () { editor.insertContent("{admin_email}") }
                },
                {
                    text: 'Checkout url',
                    onclick: function () { editor.insertContent("{checkout_url}") }
                },
                {
                    text: 'Customer name',
                    onclick: function () { editor.insertContent("{customer_name}") }
                },
                {
                    text: 'Customer note',
                    onclick: function () { editor.insertContent("{customer_note}") }
                },
                {
                    text: 'First name',
                    onclick: function () { editor.insertContent("{first_name}") }
                },
                {
                    text: 'Last name',
                    onclick: function () { editor.insertContent("{last_name}") }
                },
                {
                    text: 'My account url',
                    onclick: function () { editor.insertContent("{myaccount_url}") }
                },
                {
                    text: 'Payment url',
                    onclick: function () { editor.insertContent("{payment_url}") }
                },
                {
                    text: 'Reset password url',
                    onclick: function () { editor.insertContent("{reset_password_url}") }
                },
                {
                    text: 'Site title',
                    onclick: function () { editor.insertContent("{site_title}") }
                },
                {
                    text: 'Shop url',
                    onclick: function () { editor.insertContent("{shop_url}") }
                },
                {
                    text: 'User login',
                    onclick: function () { editor.insertContent("{user_login}") }
                },
                {
                    text: 'User email',
                    onclick: function () { editor.insertContent("{user_email}") }
                },
                {
                    text: 'Site url',
                    onclick: function () { editor.insertContent("{site_url}") }
                }
            ]
        },
        {
            text: 'Order details',
            menu: [
                {
                    text: 'Order ID',
                    onclick: function () { editor.insertContent("{order_id}") }
                },
                {
                    text: 'Order date',
                    onclick: function () { editor.insertContent("{order_date}") }
                },
                {
                    text: 'Order discount',
                    onclick: function () { editor.insertContent("{order_discount}") }
                },
                {
                    text: 'Order fully refunded',
                    onclick: function () { editor.insertContent("{order_fully_refund}") }
                },
                {
                    text: 'Order number',
                    onclick: function () { editor.insertContent("{order_number}") }
                },
                {
                    text: 'Order partial refund',
                    onclick: function () { editor.insertContent("{order_partial_refund}") }
                },
                {
                    text: 'Order received url',
                    onclick: function () { editor.insertContent("{order_received_url}") }
                },
                {
                    text: 'Order shipping',
                    onclick: function () { editor.insertContent("{order_shipping}") }
                },
                {
                    text: 'Order subtotal',
                    onclick: function () { editor.insertContent("{order_subtotal}") }
                },
                {
                    text: 'Order total',
                    onclick: function () { editor.insertContent("{order_total}") }
                },
                {
                    text: 'Order tax',
                    onclick: function () { editor.insertContent("{order_tax}") }
                },
                {
                    text: 'Payment method',
                    onclick: function () { editor.insertContent("{payment_method}") }
                },
            ]
        },
        {
            text: 'Billings',
            menu: [
                {
                    text: 'Billing first name',
                    onclick: function () { editor.insertContent("{billing_first_name}") }
                },
                {
                    text: 'Billing last name',
                    onclick: function () { editor.insertContent("{billing_last_name}") }
                },
                {
                    text: 'Billing company',
                    onclick: function () { editor.insertContent("{billing_company}") }
                },
                {
                    text: 'Billing country',
                    onclick: function () { editor.insertContent("{billing_country}") }
                },
                {
                    text: 'Billing address',
                    onclick: function () { editor.insertContent("{billing_address}") }
                },
                {
                    text: 'Billing address 1',
                    onclick: function () { editor.insertContent("{billing_address_1}") }
                },
                {
                    text: 'Billing address 2',
                    onclick: function () { editor.insertContent("{billing_address_2}") }
                },
                {
                    text: 'Billing post code',
                    onclick: function () { editor.insertContent("{billing_postcode}") }
                },
                {
                    text: 'Billing city',
                    onclick: function () { editor.insertContent("{billing_city}") }
                },
                {
                    text: 'Billing state',
                    onclick: function () { editor.insertContent("{billing_state}") }
                },
                {
                    text: 'Billing email',
                    onclick: function () { editor.insertContent("{billing_email}") }
                },
                {
                    text: 'Billing phone',
                    onclick: function () { editor.insertContent("{billing_phone}") }
                },
            ]
        },
        {
            text: 'Shippings',
            menu: [
                {
                    text: 'Shipping first name',
                    onclick: function () { editor.insertContent("{shipping_first_name}") }
                },
                {
                    text: 'Shipping last name',
                    onclick: function () { editor.insertContent("{shipping_last_name}") }
                },
                {
                    text: 'Shipping company',
                    onclick: function () { editor.insertContent("{shipping_company}") }
                },
                {
                    text: 'Shipping country',
                    onclick: function () { editor.insertContent("{shipping_country}") }
                },
                {
                    text: 'Shipping address',
                    onclick: function () { editor.insertContent("{shipping_address}") }
                },
                {
                    text: 'Shipping address 1',
                    onclick: function () { editor.insertContent("{shipping_address_1}") }
                },
                {
                    text: 'Shipping address 2',
                    onclick: function () { editor.insertContent("{shipping_address_2}") }
                },
                {
                    text: 'Shipping post code',
                    onclick: function () { editor.insertContent("{shipping_postcode}") }
                },
                {
                    text: 'Shipping city',
                    onclick: function () { editor.insertContent("{shipping_city}") }
                },
                {
                    text: 'Shipping state',
                    onclick: function () { editor.insertContent("{shipping_state}") }
                },
                {
                    text: 'Shipping method',
                    onclick: function () { editor.insertContent("{shipping_method}") }
                },
            ]
        },
    ]
}