"use strict"

function openEditorTab() {
    let tabsElement = jQuery('#iwetc-builder-left-sidebar .iwetc-tabs');
    tabsElement.find('.iwetc-tab-content').removeClass('active');
    tabsElement.find('.iwetc-tab-content[data-content="editor"]').addClass('active');
    tabsElement.find('.iwetc-tab-content[data-content="editor"] .iwetc-builder-left-sidebar-middle-content').scrollTop(0);
}

function iwetcSelect2Init() {
    if (jQuery.fn.select2) {
        if (jQuery('.iwetc-select2').length > 0) {
            jQuery('.iwetc-select2').select2({
                placeholder: 'Select ...',
                multiple: true,
                allowClear: true,
                width: 'style',
            });
        }

        if (jQuery('.iwetc-select2-coupons').length > 0) {
            let query;
            jQuery('.iwetc-select2-coupons').select2({
                ajax: {
                    type: "post",
                    delay: 200,
                    url: IWETCL_DATA.ajax_url,
                    dataType: "json",
                    data: function (params) {
                        query = {
                            action: "iwetc_get_coupons",
                            search: params.term
                        };
                        return query;
                    }
                },
                placeholder: 'Select ...',
                minimumInputLength: 1,
                width: 'style',
            });
        }

        if (jQuery('.iwetc-select2-products').length > 0) {
            let query;
            jQuery('.iwetc-select2-products').select2({
                ajax: {
                    type: "post",
                    delay: 200,
                    url: IWETCL_DATA.ajax_url,
                    dataType: "json",
                    data: function (params) {
                        query = {
                            action: "iwetc_get_products",
                            search: params.term
                        };
                        return query;
                    },
                },
                placeholder: 'Select ...',
                minimumInputLength: 1,
                width: 'style',
            });
        }

        if (jQuery('.iwetc-select2-product-categories').length > 0) {
            let query;
            jQuery('.iwetc-select2-product-categories').select2({
                ajax: {
                    type: "post",
                    delay: 200,
                    url: IWETCL_DATA.ajax_url,
                    dataType: "json",
                    data: function (params) {
                        query = {
                            action: "iwetc_get_product_categories",
                            search: params.term
                        };
                        return query;
                    }
                },
                placeholder: 'Select ...',
                minimumInputLength: 1,
                width: 'style',
            });
        }

        if (jQuery('.iwetc-select2-posts').length > 0) {
            let query;
            jQuery('.iwetc-select2-posts').select2({
                ajax: {
                    type: "post",
                    delay: 200,
                    url: IWETCL_DATA.ajax_url,
                    dataType: "json",
                    data: function (params) {
                        query = {
                            action: "iwetc_get_posts",
                            search: params.term
                        };
                        return query;
                    }
                },
                placeholder: 'Select ...',
                minimumInputLength: 1,
                width: 'style',
            });
        }

        if (jQuery('.iwetc-select2-post-categories').length > 0) {
            let query;
            jQuery('.iwetc-select2-post-categories').select2({
                ajax: {
                    type: "post",
                    delay: 200,
                    url: IWETCL_DATA.ajax_url,
                    dataType: "json",
                    data: function (params) {
                        query = {
                            action: "iwetc_get_post_categories",
                            search: params.term
                        };
                        return query;
                    }
                },
                placeholder: 'Select ...',
                minimumInputLength: 1,
                width: 'style',
            });
        }


        // fix placeholder bug
        jQuery('.iwetc-select2').each(function () {
            if (!jQuery(this).val() || (jQuery.isArray(jQuery(this).val()) && jQuery(this).val().length < 1)) {
                jQuery(this).closest('div').find('.select2-search--inline .select2-search__field').css({
                    width: '100%'
                });
            }
        });
    }
}

function iwetcBuilderReInit() {
    iwetcColorPickerInit();
    iwetcMediaUploaderInit();
    iwetcTextEditorInit();
    iwetcSelect2Init();
    iwetcShortcodeInit();
}

function iwetcShortcodeInit() {
    if (jQuery('.iwetc-has-shortcode').length > 0) {
        jQuery.each(jQuery('.iwetc-has-shortcode'), function () {
            if (jQuery(this).find('.iwetc-shortcode-button').length < 1) {
                let position = (jQuery(this).attr('data-shortcode-position')) ? jQuery(this).attr('data-shortcode-position') : 'right';
                jQuery(this).append('<div class="iwetc-shortcode-button" data-shortcode-position="' + position + '" data-shortcode-id="' + jQuery(this).attr('data-shortcode-id') + '"><i class="dashicons dashicons-menu"></i></div>');
            }
        });
    }
}

function iwetcTextEditorInit() {
    if (jQuery('#iwetc-text-editor').length > 0) {
        wp.editor.remove('iwetc-text-editor');
        iwetcBuilderEditorSettings.tinymce.setup = function (editor) {
            editor.addButton('shortcode', {
                type: 'menubutton',
                text: 'Shortcode',
                icon: false,
                menu: iwetcTextEditorShortcodes(editor),
            });
            editor.on('change input keyup', function (e) {
                iwetcBuilderElementUpdate({
                    type: 'html',
                    property: null,
                    unit: null,
                    value: editor.getContent()
                });
            });
        }
        wp.editor.initialize('iwetc-text-editor', iwetcBuilderEditorSettings);
    }

    if (jQuery('#iwetc-coupon-text-editor').length > 0) {
        wp.editor.remove('iwetc-coupon-text-editor');
        iwetcCouponTextEditorSettings.tinymce.setup = function (editor) {
            let shortcodes = iwetcTextEditorShortcodes(editor);
            shortcodes.push({
                text: "Coupon",
                menu: [
                    {
                        text: 'Coupon Code',
                        onclick: function () { editor.insertContent("{coupon_code}") }
                    }, {
                        text: 'Coupon expire date',
                        onclick: function () { editor.insertContent("{coupon_expire_date}") }
                    }, {
                        text: 'Coupon amount',
                        onclick: function () { editor.insertContent("{coupon_amount}") }
                    },
                ]
            })

            editor.addButton('shortcode', {
                type: 'menubutton',
                text: 'Shortcode',
                icon: false,
                menu: shortcodes,
            });

            editor.on('change input keyup', function (e) {
                iwetcBuilderElementUpdate({
                    type: 'html',
                    property: null,
                    unit: null,
                    value: editor.getContent()
                });
            });
        }

        wp.editor.initialize('iwetc-coupon-text-editor', iwetcCouponTextEditorSettings);
    }
}

function iwetcColorPickerInit() {
    if (jQuery('.iwetc-color-picker').length > 0) {

        jQuery('.iwetc-color-picker').wpColorPicker({
            change: function (event, ui) {
                jQuery(event.target).closest('.wp-picker-container').find('.iwetc-color-picker-code').text(ui.color.toString());
                iwetcBuilderElementUpdate({
                    type: 'style',
                    property: jQuery(event.target).attr('data-property'),
                    target: (jQuery(event.target).attr('data-target')) ? jQuery(event.target).attr('data-target') : null,
                    unit: null,
                    value: ui.color.toString()
                });
            },
            clear: function (event) {
                let target = (jQuery(event.target).closest('.wp-picker-container').find('.iwetc-color-picker')) ? jQuery(event.target).closest('.wp-picker-container').find('.iwetc-color-picker').attr('data-target') : null;
                iwetcBuilderElementUpdate({
                    type: 'style',
                    property: jQuery(event.target).closest('.wp-picker-input-wrap').find('.iwetc-color-picker').attr('data-property'),
                    target: target,
                    unit: null,
                    value: 'transparent'
                });
            }
        });

        setTimeout(function () {
            if (jQuery('.wp-picker-container').length > 0) {
                jQuery('.wp-picker-container').each(function (i, element) {
                    jQuery(this).find('.wp-picker-holder').css({
                        right: (jQuery(element).offset().left - jQuery('#iwetc-builder-left-sidebar').offset().left > 100) ? 0 : 'auto',
                        left: (jQuery(element).offset().left - jQuery('#iwetc-builder-left-sidebar').offset().left > 100) ? 'auto' : 0,
                        bottom: ((jQuery(element).offset().top - jQuery('#iwetc-builder-left-sidebar').offset().top) / window.innerHeight) > 0.8 ? '60px' : '',
                        top: ((jQuery(element).offset().top - jQuery('#iwetc-builder-left-sidebar').offset().top) / window.innerHeight) > 0.8 ? '' : '60px'
                    });

                    jQuery(this).find('.wp-picker-input-wrap').css({
                        right: (jQuery(element).offset().left - jQuery('#iwetc-builder-left-sidebar').offset().left > 100) ? 0 : 'auto',
                        left: (jQuery(element).offset().left - jQuery('#iwetc-builder-left-sidebar').offset().left > 100) ? 'auto' : 0,
                        bottom: ((jQuery(element).offset().top - jQuery('#iwetc-builder-left-sidebar').offset().top) / window.innerHeight) > 0.8 ? '30px' : '',
                        top: ((jQuery(element).offset().top - jQuery('#iwetc-builder-left-sidebar').offset().top) / window.innerHeight) > 0.8 ? '' : '30px'
                    });

                    if (jQuery(this).find('.iwetc-color-picker-clear').length < 1) {
                        jQuery(this).prepend('<span class="iwetc-color-picker-code" onClick="iwetcOpenColorPicker(this)"></span><button type="button" class="iwetc-color-picker-clear" onClick="iwetcClearColor(this)"><i class="dashicons dashicons-no-alt"></i></button>');
                    }
                });
            }
        }, 150)
    }
}

function iwetcMediaUploaderInit() {
    if (jQuery('.iwetc-media-uploader.with-clear-button').length > 0) {
        jQuery('.iwetc-media-uploader.with-clear-button').each(function (i, element) {
            if (jQuery(this).find('.iwetc-media-clear').length < 1) {
                jQuery(this).prepend('<button type="button" class="iwetc-media-clear"><i class="dashicons dashicons-no-alt"></i></button>');
            }
        });
    }
}

function iwetcClearColor(item) {
    jQuery(item).closest('.wp-picker-container').find('.iwetc-color-picker-code').text('');
    jQuery(item).closest('.wp-picker-container').find('.wp-picker-clear').trigger('click');
}

function iwetcOpenColorPicker(item) {
    jQuery(item).closest('.wp-picker-container').find('.wp-color-result').trigger('click');
}

function iwetcCloseEditor() {
    jQuery('.iwetc-element-editable').removeClass('iwetc-element-focus');
    jQuery('.iwetc-layout-editable').removeClass('iwetc-element-focus');
    jQuery('.iwetc-layout-column').removeClass('iwetc-element-focus');
    jQuery('.iwetc-tabs-title li a[data-content="components"]').trigger('click');
}

function iwetcBuilderElementUpdate(data) {
    let parentElement;
    let selectedElement;
    let type = jQuery('.iwetc-element-focus').attr('data-type');

    if (type == 'layout') {
        selectedElement = jQuery('.iwetc-element-focus').find('.iwetc-layout-content');
    } else if (type == 'column') {
        selectedElement = jQuery('.iwetc-element-focus');
    } else {
        parentElement = selectedElement = jQuery('.iwetc-element-focus').find('.iwetc-element-content');
        if (selectedElement.find('.iwetc-builder-content-target').length > 0) {
            selectedElement = selectedElement.find('.iwetc-builder-content-target');
        }
    }

    if (data.target) {
        if (!selectedElement.hasClass((data.target).replace('.', '').replace('#', ''))) {
            selectedElement = (jQuery.inArray(data.target, ['#iwetc-builder-body', '.iwetc-builder-body-wrapper']) !== -1) ? jQuery(data.target) : selectedElement.find(data.target);
        }
    }

    switch (data.type) {
        case 'change_columns':
            iwetcLayoutChangeColumns(data);
            break;
        case 'html':
            selectedElement.html(data.value);
            break;
        case 'text':
            selectedElement.text(data.value);
            break;
        case 'style':
            if (data.target) {
                if (data.property == 'display' && jQuery.inArray(data.target, ['.iwetc-directional li', '.iwetc-directional']) !== -1 && selectedElement.length > 0) {
                    jQuery.each(selectedElement, function () {
                        if (jQuery(this).css('display') != 'none') {
                            jQuery(this).css({
                                [data.property]: data.value
                            });
                        }
                    })
                } else {
                    selectedElement.css({
                        [data.property]: (data.unit) ? data.value + data.unit : data.value
                    });
                }
            } else {
                if (jQuery.inArray(data.property, ['text-align']) !== -1) {
                    parentElement.css({
                        [data.property]: (data.unit) ? data.value + data.unit : data.value
                    });
                } else {
                    selectedElement.css({
                        [data.property]: (data.unit) ? data.value + data.unit : data.value
                    });
                }
            }
            break;
        case 'attribute':
            switch (data.property) {
                case 'href':
                    if (data.value != '') {
                        selectedElement.attr(data.property, data.value);
                    } else {
                        selectedElement.removeAttr(data.property);
                    }
                    break;
                case 'src':
                    if (data.value != '') {
                        selectedElement.attr(data.property, data.value);
                    } else {
                        selectedElement.remove();
                    }
                    break;
                default:
                    selectedElement.attr(data.property, data.value);
                    break;

            }
            break;
        case 'order_details_template':
            selectedElement.find('.iwetc-has-template').attr('data-template', data.value);
            selectedElement.html(IwetcBuilder.Component.DefaultValue.order_details[data.value]).ready(function () {
                jQuery('.iwetc-builder-editor-input').trigger('input');
                if (data.value == 'default') {
                    jQuery('.iwetc-element-focus tbody td[data-name="order_details_product_name"]').css({
                        "font-size": 'inherit',
                        "line-height": 'inherit'
                    });
                }

                setTimeout(function () {
                    selectedElement.closest('.iwetc-element-editable').removeClass('iwetc-element-focus').trigger('click');
                }, 200)
            });
            break;
        case 'order_details_show_sku':
            if (data.value === true) {
                selectedElement.find('[data-name="order_details_product_name"]').addClass('iwetc-has-sku').append('<span data-name="sku"> (SKU) </span>');
            } else {
                selectedElement.find('[data-name="order_details_product_name"]').removeClass('iwetc-has-sku');
                selectedElement.find('[data-name="sku"]').remove();
            }
            break;
        case 'translate':
            if (selectedElement.hasClass('iwetc-text-translatable')) {
                selectedElement.text(data.value)
            } else {
                selectedElement.find('.iwetc-text-translatable[data-name="' + data.property + '"]').text(data.value)
            }
            break;
        case 'character_limit':
            selectedElement.attr('data-character-limit', parseInt(data.value));
            let originText = selectedElement.first().attr('data-origin-text');
            if (originText.length > data.value) {
                selectedElement.text(originText.substring(0, parseInt(data.value)) + '...');
            } else {
                selectedElement.text(originText);
            }
            break;
        case 'items_distance_vertical':
            selectedElement.find('[data-name="items_distance_vertical"]').css({ 'padding-bottom': data.value + 'px' });
            break;
        case 'items_distance_horizontal':
            selectedElement.find('[data-name="items_distance_horizontal"]').css({ 'padding-left': data.value + 'px' });
            break;
        case 'add_remove_social_item':
            let display;
            if (data.value == true) {
                display = (selectedElement.find('.iwetc-directional').attr('data-direction') == 'horizontal') ? 'inline-block' : 'block';
            } else {
                display = 'none';
            }

            selectedElement.find('[data-name="' + data.property + '"]').css({ 'display': display });
            break;
    }
}

function iwetcLayoutChangeColumns(data) {
    let layout = jQuery('.iwetc-element-focus');
    let currentColumns = layout.attr('data-columns');
    let layoutObject = IwetcBuilder.Component.getElement(data.value);
    layout.attr('data-element-name', layoutObject.name).attr('data-columns', layoutObject.columns);

    if (layoutObject.columns > 0 && layoutObject.columns <= 4) {
        let diff = Math.abs(currentColumns - layoutObject.columns);
        if (currentColumns > layoutObject.columns) {
            for (let i = 0; i < diff; i++) {
                layout.find('.iwetc-layout-column-wrap').last().remove();
            }
        } else {
            for (let i = 0; i < diff; i++) {
                let lastRow = layout.find('.iwetc-layout-column-wrap').last();
                let clone = lastRow.clone();
                lastRow.after(clone);
            }
        }

        let width = (100 / parseInt(layoutObject.columns)).toFixed(2) * 1;
        layout.find('.iwetc-layout-column-wrap').css({ width: width + '%' });
        layout.find('.iwetc-layout-column').removeClass('iwetc-layout-col-' + currentColumns).addClass('iwetc-layout-col-' + layoutObject.columns).attr('data-width', width);

        jQuery('.iwetc-properties-horizontal-column-distance-input').trigger('change');
        IwetcBuilder.Component.contentSortableInit();
    }
}

function iwetcTinyMceSetContent(editorId, content) {
    tinyMCE.get(editorId).setContent(content);
}

function iwetcGetEmailStructure() {
    let output = {},
        layoutAttributes,
        contents,
        columns,
        columnAttributes,
        layoutContentAttributes,
        contentAttributes,
        elementContentAttributes,
        element,
        translate = {},
        childrenAttributes;

    let backgroundImage = jQuery('#iwetc-builder-body').css('background-image');
    let backgroundColor = jQuery('#iwetc-builder-body').css('background-color');
    let wrapperWidth = parseInt(jQuery('.iwetc-builder-body-wrapper').css('width'));

    output.container = {
        style: 'background-color: ' + backgroundColor + '; background-image: ' + backgroundImage + ';'
    }
    output.wrapper = {
        style: 'width:' + wrapperWidth + 'px;',
        responsive_point: parseInt(jQuery('.iwetc-builder-body-wrapper').attr('data-responsive-point'))
    }
    output.custom_css = jQuery('#iwetc-custom-css').val();

    output.rows = [];

    let rows = jQuery('.iwetc-layout-editable');
    if (rows.length > 0) {
        jQuery.each(rows, function (i, layoutItem) {
            layoutAttributes = {};
            layoutContentAttributes = {};
            if (this.attributes) {
                jQuery.each(this.attributes, function () {
                    layoutAttributes[this.name] = this.value;
                });
            }

            if (jQuery(this).find('.iwetc-layout-content').length > 0) {
                jQuery.each(jQuery(this).find('.iwetc-layout-content'), function () {
                    if (this.attributes) {
                        jQuery.each(this.attributes, function () {
                            layoutContentAttributes[this.name] = this.value;
                        });
                    }
                });
            }

            columns = [];
            if (jQuery(layoutItem).find('.iwetc-layout-column').length > 0) {
                jQuery(layoutItem).find('.iwetc-layout-column').each(function () {
                    columnAttributes = {};

                    if (this.attributes) {
                        jQuery.each(this.attributes, function () {
                            columnAttributes[this.name] = this.value;
                        });
                    }

                    contents = [];
                    if (jQuery(this).find('.iwetc-element-editable').length > 0) {
                        jQuery(this).find('.iwetc-element-editable').each(function () {
                            element = IwetcBuilder.Component.getElement(jQuery(this).attr('data-element-name'));
                            let $this = jQuery(this);
                            if (element.name) {
                                contentAttributes = {};
                                elementContentAttributes = {};
                                childrenAttributes = {};

                                if (this.attributes) {
                                    jQuery.each(this.attributes, function () {
                                        contentAttributes[this.name] = this.value;
                                    });
                                }

                                if ($this.find('.iwetc-element-content').length > 0) {
                                    jQuery.each($this.find('.iwetc-element-content'), function () {
                                        jQuery.each(this.attributes, function () {
                                            elementContentAttributes[this.name] = this.value;
                                        });
                                    });
                                }

                                if ($this.find('.iwetc-has-column')) {
                                    contentAttributes['data-column'] = $this.find('.iwetc-has-column').attr('data-column');
                                }

                                if ($this.find('.iwetc-has-add-to-cart')) {
                                    contentAttributes['data-add-to-cart'] = $this.find('.iwetc-has-add-to-cart').attr('data-add-to-cart');
                                }

                                if ($this.find('.iwetc-has-row')) {
                                    contentAttributes['data-row'] = $this.find('.iwetc-has-row').attr('data-row');
                                }

                                if ($this.find('.iwetc-has-type')) {
                                    contentAttributes['data-type'] = $this.find('.iwetc-has-type').attr('data-type');

                                    if ($this.find('.iwetc-has-type').attr('data-products')) {
                                        contentAttributes['data-products'] = $this.find('.iwetc-has-type').attr('data-products');
                                    }
                                    if ($this.find('.iwetc-has-type').attr('data-exclude-products')) {
                                        contentAttributes['data-exclude-products'] = $this.find('.iwetc-has-type').attr('data-exclude-products');
                                    }
                                    if ($this.find('.iwetc-has-type').attr('data-categories')) {
                                        contentAttributes['data-categories'] = $this.find('.iwetc-has-type').attr('data-categories');
                                    }
                                    if ($this.find('.iwetc-has-type').attr('data-exclude-categories')) {
                                        contentAttributes['data-exclude-categories'] = $this.find('.iwetc-has-type').attr('data-exclude-categories');
                                    }
                                }

                                if ($this.find('.iwetc-has-category')) {
                                    contentAttributes['data-category'] = $this.find('.iwetc-has-category').attr('data-category');
                                }

                                if ($this.find('.iwetc-has-included')) {
                                    contentAttributes['data-included'] = $this.find('.iwetc-has-included').attr('data-included');
                                }

                                if ($this.find('.iwetc-has-excluded')) {
                                    contentAttributes['data-excluded'] = $this.find('.iwetc-has-excluded').attr('data-excluded');
                                }

                                if ($this.find('.iwetc-has-template')) {
                                    contentAttributes['data-template'] = $this.find('.iwetc-has-template').attr('data-template');
                                }

                                if ($this.find('[data-name="sku"]').length > 0) {
                                    contentAttributes['show-sku'] = 'yes';
                                }

                                if (element.childrenNames && element.childrenNames.length > 0) {
                                    jQuery.each(element.childrenNames, function (i, elementName) {
                                        childrenAttributes[elementName] = {};

                                        if ($this.find('.iwetc-text-translatable[data-name="' + elementName + '"]').length > 0) {
                                            translate[elementName] = $this.find('.iwetc-text-translatable[data-name="' + elementName + '"]').first().text();
                                        }

                                        if ($this.find('[data-name="' + elementName + '"]').first()) {
                                            jQuery.each($this.find('[data-name="' + elementName + '"]').first(), function (i, item) {
                                                if (item.attributes) {
                                                    jQuery.each(item.attributes, function () {
                                                        childrenAttributes[elementName][this.name] = this.value
                                                        if (jQuery.inArray(this.value, ['coupon_code', 'add_to_cart_button']) !== -1) {
                                                            childrenAttributes[elementName]['value'] = jQuery(item).text();
                                                        }
                                                    });
                                                }
                                            })
                                        }
                                    });
                                }

                                let targetElement = $this.find('.iwetc-element-content .iwetc-builder-content-target');
                                contents.push({
                                    name: element.name,
                                    translate: translate,
                                    attributes: contentAttributes,
                                    element_content_attributes: elementContentAttributes,
                                    children_attributes: childrenAttributes,
                                    custom_class_in_html: (targetElement.length > 0 && targetElement.attr('data-custom-class')) ? targetElement.attr('data-custom-class') : '',
                                    html: $this.find('.iwetc-element-content').html(),
                                });
                            }
                        })
                    }

                    columns.push({
                        attributes: columnAttributes,
                        // style: (jQuery(this).attr('style')) ? jQuery(this).attr('style') : '',
                        contents: contents
                    })
                });
            }

            output.rows.push({
                layout: {
                    attributes: layoutAttributes,
                    layout_content_attributes: layoutContentAttributes,
                    distance: (jQuery(layoutItem).find('.iwetc-layout-content').attr('data-distance')) ? jQuery(layoutItem).find('.iwetc-layout-content').attr('data-distance') : 0,
                    // style: (jQuery(layoutItem).find('.iwetc-layout-content').attr('style')) ? jQuery(layoutItem).find('.iwetc-layout-content').attr('style') : ''
                },
                columns: columns,
            })
        })
    }

    return output;
}

function iwetcGetEmailPreview() {
    jQuery('.iwetc-builder-email-preview-loading').show();
    jQuery('#iwetc-modal-email-preview').find('.iwetc-builder-preview-container').html('');

    jQuery.ajax({
        method: 'post',
        dataType: 'json',
        url: IWETCL_DATA.ajax_url,
        data: {
            action: 'iwetc_get_email_preview',
            order_id: jQuery('#iwetc-builder-order').val(),
            custom_css: jQuery('#iwetc-custom-css').val(),
            direction: jQuery('#iwetc-direction').val(),
            email_structure: iwetcGetEmailStructure()
        },
        success: function (response) {
            jQuery('.iwetc-builder-email-preview-loading').hide();
            jQuery('#iwetc-modal-email-preview').find('.iwetc-builder-preview-container').html(response.email_rendered);
        },
        error: function (e) {
            jQuery('.iwetc-builder-email-preview-loading').hide();
        },
    })
}

function iwetcImportTemplate(templateStructure) {
    if (templateStructure) {
        let structure = (templateStructure instanceof Object) ? templateStructure : JSON.parse(templateStructure);
        jQuery('.iwetc-email-body').html(iwetcParseEmailStructure(structure)).ready(function () {
            if (structure.custom_css != '') {
                jQuery('#iwetc-custom-css').val(structure.custom_css).trigger('change');
            }
            if (structure.wrapper && structure.wrapper.responsive_point) {
                jQuery('#iwetc-builder-responsive-point').val(structure.wrapper.responsive_point).trigger('change');
            }
            IwetcBuilder.Component.init();
        });
    }
}

function iwetcSendTestEmail() {
    jQuery.ajax({
        method: 'post',
        dataType: 'json',
        url: IWETCL_DATA.ajax_url,
        data: {
            action: 'iwetc_send_test_email',
            order_id: jQuery('#iwetc-builder-order').val(),
            to_email: jQuery('#iwetc-to-email').val(),
            custom_css: jQuery('#iwetc-custom-css').val(),
            direction: jQuery('#iwetc-direction').val(),
            email_subject: jQuery('#title').val(),
            email_structure: iwetcGetEmailStructure()
        },
        success: function (response) {
            if (response.sent) {
                swal("Your email has been sent successfully", "", "success");
            } else {
                swal("Error ! Try again", "", "warning");
            }
        },
        error: function (e) {
            swal("Error ! Try again", "", "warning");
        },
    })
}

function iwetcParseEmailStructure(structure) {
    let data = (structure instanceof Object) ? structure : JSON.parse(structure);
    let output = '';

    if (data.rows && data.rows.length > 0) {
        jQuery.each(data.rows, function (i, row) {
            if (row.layout) {
                // set layout attributes
                let layoutAttributes = '';
                let layoutContentAttributes = '';
                let columnDistance = (row.layout.distance) ? parseInt(row.layout.distance) : 0;
                if (row.layout.attributes) {
                    jQuery.each(row.layout.attributes, function (key, value) {
                        if (key && value) {
                            layoutAttributes += key + '="' + value + '" ';
                        }
                    });
                }

                if (row.layout.layout_content_attributes) {
                    jQuery.each(row.layout.layout_content_attributes, function (key, value) {
                        if (key && value) {
                            layoutContentAttributes += key + '="' + value + '" ';
                        }
                    });
                }

                output += '<div ' + layoutAttributes + '>';
                output += '<div ' + layoutContentAttributes + '>';
                output += '<div class="iwetc-layout-row" style="width: 100%; display: inline-block; box-sizing: border-box; -moz-box-sizing: border-box; -webkit-box-sizing: border-box;">';

                // set columns
                if (row.columns) {
                    jQuery.each(row.columns, function (i, column) {
                        // set column attributes
                        let columnAttributes = '';
                        let columnWidth = 'auto';
                        if (column.attributes) {
                            jQuery.each(column.attributes, function (key, value) {
                                if (key && value) {
                                    if (key == 'data-width') {
                                        columnWidth = value;
                                    }
                                    columnAttributes += key + '="' + value + '" ';
                                }
                            });
                        }

                        let diff = columnDistance - (columnDistance / parseInt(row.columns.length));
                        let width = (columnWidth != 'auto') ? 'calc(' + columnWidth + '% - ' + diff + 'px)' : 'auto';
                        let marginLeft = (i == 0) ? '0' : columnDistance + 'px';

                        output += '<div class="iwetc-layout-column-wrap" style="width: ' + width + '; margin-left: ' + marginLeft + ';">';
                        output += '<div ' + columnAttributes + '>';

                        // set contents
                        if (column.contents) {
                            jQuery.each(column.contents, function (i, content) {
                                // set content attributes
                                let contentAttributes = '';
                                let elementContentAttributes = '';

                                if (content.attributes) {
                                    jQuery.each(content.attributes, function (key, value) {
                                        if (key && value) {
                                            contentAttributes += key + '="' + value + '" ';
                                        }
                                    });
                                }

                                if (content.element_content_attributes) {
                                    jQuery.each(content.element_content_attributes, function (key, value) {
                                        if (key && value) {
                                            elementContentAttributes += key + '="' + value + '" ';
                                        }
                                    });
                                }

                                output += '<div class="iwetc-content-draggable">';
                                output += '<div ' + contentAttributes + '>';
                                output += '<div ' + elementContentAttributes + '>';
                                output += content.html;
                                output += '</div>';
                                output += '<div class="iwetc-content-handler-buttons">';
                                output += '<button type="button" class="iwetc-content-edit-handler"><i class="dashicons dashicons-edit" title="' + IwetcBuilder.Translate.edit + '"></i></button>';
                                output += '<button type="button" class="iwetc-content-duplicate-handler"><i class="dashicons dashicons-admin-page" title="' + IwetcBuilder.Translate.duplicate + '"></i></button>';
                                output += '<button type="button" class="iwetc-content-delete-handler"><i class="dashicons dashicons-trash" title="' + IwetcBuilder.Translate.delete + '"></i></button>';
                                output += '</div>';
                                output += '</div>';
                                output += '</div>';
                            });
                        }
                        output += '<button type="button" class="iwetc-column-edit-handler"><i class="dashicons dashicons-edit" title="Edit Column"></i></button></div></div>';
                    })
                }

                output += '<div class="iwetc-layout-handler-left">';
                output += '<button type="button" class="iwetc-layout-move-handler"><i class="dashicons dashicons-move" title="' + IwetcBuilder.Translate.move + '"></i></button>';
                output += '<button type="button" class="iwetc-layout-edit-handler"><i class="dashicons dashicons-edit" title="' + IwetcBuilder.Translate.edit + '"></i></button>';
                output += '<button type="button" class="iwetc-layout-duplicate-handler"><i class="dashicons dashicons-admin-page" title="' + IwetcBuilder.Translate.duplicate + '"></i></button>';
                output += '</div>';
                output += '<div class="iwetc-layout-handler-right">';
                output += '<button type="button" class="iwetc-layout-copy-handler"><i class="dashicons dashicons-welcome-add-page" title="' + IwetcBuilder.Translate.copy + '"></i></button>';
                output += '<button type="button" class="iwetc-layout-paste-handler"><i class="dashicons dashicons-arrow-down-alt" title="' + IwetcBuilder.Translate.paste + '"></i></button>';
                output += '<button type="button" class="iwetc-layout-delete-handler"><i class="dashicons dashicons-trash" title="' + IwetcBuilder.Translate.delete + '"></i></button>';
                output += '</div>';
                output += '</div>';
                output += '</div>';
                output += '<button type="button" class="iwetc-add-new-row"><i class="dashicons dashicons-insert"></i></button>';
                output += '</div>';
            }
        });
    }

    return output;
}

function iwetcMenuBarAddItem() {
    let newItem;
    let tableElement;
    let divider = jQuery('.iwetc-menu-bar-divider-enable').prop('checked');
    let direction = jQuery('.iwetc-change-table-direction').val();
    let display = divider === true ? 'table-cell' : 'none';
    let borderColor = (jQuery('.iwetc-menu-bar-divider-color').val() == 'rgba(0, 0, 0, 0)') ? 'transparent' : jQuery('.iwetc-menu-bar-divider-color').val();
    let borderStyle = (direction == 'vertical') ? 'border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color:' + borderColor + ';' : 'border-left-width: 1px; border-left-style: solid; border-left-color:' + borderColor + ';';
    let dividerStyle = 'display: ' + display + '; ' + borderStyle;

    let id = iwetcGenerateId(6);
    let itemsLength = parseInt(jQuery('.iwetc-element-focus .iwetc-menu-bar-table td[data-name="menu_bar_item"]').length);

    if (direction == 'vertical') {
        tableElement = jQuery('.iwetc-element-focus .iwetc-menu-bar-table tbody');
        newItem = (itemsLength > 0) ? '<tr><td data-name="menu_bar_divider" data-id="' + id + '" style="' + dividerStyle + '"></td></tr>' : '';
        newItem += '<tr><td data-name="menu_bar_item" data-id="' + id + '"><a href="#" target="_blank" style="color: inherit;" data-name="' + id + '">Menu item</a></td></tr>';
    } else {
        tableElement = jQuery('.iwetc-element-focus .iwetc-menu-bar-table tbody tr');
        newItem = (itemsLength > 0) ? '<td data-name="menu_bar_divider" data-id="' + id + '" style="' + dividerStyle + '"></td>' : '';
        newItem += '<td data-name="menu_bar_item" data-id="' + id + '"><a href="#" target="_blank" style="color: inherit;" data-name="' + id + '">Menu item</a></td>';
    }

    jQuery('#iwetc-menu-bar-items').append(iwetcMenuBarGetItem(id));
    tableElement.append(newItem).ready(function () {
        iwetcShortcodeInit();
    });
}

function iwetcMenuBarGetItem(id) {
    let element = jQuery('.iwetc-element-focus .iwetc-menu-bar-table td[data-id="' + id + '"] a');
    let data = {
        text: (element.text()) ? element.text() : 'Menu item',
        link: (element.attr('href')) ? element.attr('href') : '#',
        target: (element.attr('target')) ? (element.attr('target')) : '_blank'
    };

    let output = '<div class="iwetc-menu-bar-item" data-id="' + id + '"><div class="iwetc-builder-left-sidebar-subsection-title iwetc-menu-bar-item-title" style="margin-bottom: 0; margin-top: 10px;">' +
        '<strong data-name="menu-bar-item-label">' + data.text + '</strong>' +
        '<i class="dashicons dashicons-arrow-down"></i>' +
        '<button type="button" class="iwetc-menu-bar-item-delete-button"><i class="dashicons dashicons-trash"></i></button>' +
        '</div>' +
        '<div class="iwetc-menu-bar-item-fields">' +
        '<div class="iwetc-builder-col-12">' +
        '<label>Text</label>' +
        '<input type="text" value="' + data.text + '" placeholder="Text ..." class="iwetc-builder-editor-input" data-type="text" data-target="[data-name=\'' + id + '\']">' +
        '</div>' +
        '<div class="iwetc-builder-col-12">' +
        '<label>Link</label>' +
        '<div class="iwetc-has-shortcode" data-shortcode-id="menu_bar_item_' + id + '_link" data-shortcode-position="right">' +
        '<input type="text" value="' + data.link + '" placeholder="Link ..." class="iwetc-builder-editor-input" data-type="attribute" data-property="href" data-target="[data-name=\'' + id + '\']">' +
        '</div>' +
        '</div>' +
        '<div class="iwetc-builder-col-12">' +
        '<label>Target</label>' +
        '<select class="iwetc-builder-editor-input" data-type="attribute" data-property="target" data-target="[data-name=\'' + id + '\']">' +
        '<option value="_blank" ';
    output += (data.target == '_blank') ? 'selected' : '';
    output += '>_blank</option><option value="_self" ';
    output += (data.target == '_self') ? 'selected' : '';
    output += '>_self</option><option value="_parent" ';
    output += (data.target == '_parent') ? 'selected' : '';
    output += '>_parent</option><option value="_top" ';
    output += (data.target == '_top') ? 'selected' : '';
    output += '>_top</option>' +
        '</select>' +
        '</div></div></div>';

    return output;
}

function iwetcContactAddItem() {
    let id = iwetcGenerateId(6);

    jQuery('#iwetc-sidebar-contact-items').append(iwetcContactGetItem(id));

    let itemHtml = '<div class="iwetc-contact-item" data-id="' + id + '">' +
        '<a href="#" style="display: inline-block; margin-bottom: 7px; color: inherit;" data-name="contact_item_url_' + id + '">' +
        '<span data-name="contact_item_image_' + id + '"></span>' +
        '<span data-name="contact_item_text_' + id + '" style="display: inline-block; line-height: 20px; margin-left: 10px;">Contact item</span>' +
        '</a></div>';

    jQuery('.iwetc-element-focus #iwetc-contact-items').append(itemHtml).ready(function () {
        iwetcMediaUploaderInit();
    });
}

function iwetcContactGetItem(id) {
    let element = jQuery('.iwetc-element-focus .iwetc-contact-item[data-id="' + id + '"] a');
    let data = {
        text: (element.text()) ? element.text() : 'Contact item',
        link: (element.attr('href')) ? element.attr('href') : '#',
        target: (element.attr('target')) ? (element.attr('target')) : '_blank'
    };

    let output = '<div class="iwetc-contact-item-container" data-id="' + id + '"><div class="iwetc-builder-left-sidebar-subsection-title iwetc-contact-item-title" style="margin-bottom: 0; margin-top: 10px;">' +
        '<strong data-name="contact-item-label">Contact item</strong>' +
        '<i class="dashicons dashicons-arrow-down"></i>' +
        '<button type="button" class="iwetc-contact-item-delete-button"><i class="dashicons dashicons-trash"></i></button>' +
        '</div>' +
        '<div class="iwetc-contact-item-fields">' +
        '<div class="iwetc-builder-col-12">' +
        '<label>Choose icon</label>' +
        '<div class="iwetc-media-uploader with-clear-button">' +
        '<button type="button" class="iwetc-open-media" data-type="attribute" data-property="src" data-id="' + id + '" data-target="[data-name=\'contact_item_image_' + id + '\'] img">Select</button>' +
        '</div>' +
        '</div>' +
        '<div class="iwetc-builder-col-12">' +
        '<label>Text</label>' +
        '<input type="text" value="' + data.text + '" class="iwetc-builder-editor-input" data-type="text" data-target="[data-name=\'contact_item_text_' + id + '\']">' +
        '</div>' +
        '<div class="iwetc-builder-col-12">' +
        '<label>Link</label>' +
        '<input type="text" value="' + data.link + '" class="iwetc-builder-editor-input" data-type="attribute" data-property="href" data-target="[data-name=\'contact_item_url_' + id + '\']">' +
        '</div>' +
        '</div>' +
        '</div>';
    return output;
}

jQuery.iwetcNl2br = function (input) {
    return input.replace(/(\r\n|\n\r|\r|\n)/g, "<br>");
};

function iwetcGenerateId(length) {
    var result = '';
    var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
}

function iwetcUpdateTheme(themeName) {
    jQuery.ajax({
        method: 'post',
        dataType: 'json',
        url: IWETCL_DATA.ajax_url,
        data: {
            action: 'iwetc_update_theme',
            theme_name: themeName
        },
        success: function (response) { },
        error: function (e) { },
    })
}

function iwetcUpdateColumnsDistance(columnDistance, columnsCount, columnsWrap) {
    let distance = (columnDistance != '') ? columnDistance : 0;
    let diff = distance - (distance / parseInt(columnsCount));

    if (columnsWrap.length > 0) {
        let columnWidth;
        jQuery.each(columnsWrap, function () {
            columnWidth = jQuery(this).find('.iwetc-layout-column').attr('data-width');
            jQuery(this).css({
                "width": 'calc(' + columnWidth + '% - ' + diff + 'px)',
                "margin-left": distance + 'px'
            });
        })
    }
}