jQuery(document).ready(function ($) {
    "use strict"

    // open
    $(document).on("click", "[data-toggle=modal]", function () {
        let modal = $($(this).attr("data-target"));

        modal.fadeIn();
        modal.find(".iwetc-modal-box").fadeIn();
        $("#iwetc-last-modal-opened").val($(this).attr("data-target"));

        // set height for modal body
        setTimeout(function () {
            iwetcFixModalHeight(modal);
        }, 150)
    });

    // close
    $(document).on("click", "[data-toggle=modal-close]", function () {
        iwetcCloseModal();
    });
    $(document).on("keyup", function (e) {
        // esc pressed
        if (e.keyCode === 27) {
            iwetcCloseModal();
        }
    });
    $(document).on('click', '.iwetc-modal-container', function (e) {
        if ($(e.target).hasClass('iwetc-modal-container')) {
            iwetcCloseModal();
        }
    });
});

function iwetcFixModalHeight(modal) {
    let footerHeight = 0;
    let contentHeight = (modal.find('.iwetc-modal-box').hasClass('iwetc-modal-full-height')) ? parseInt(jQuery(window).height()) : modal.find(".iwetc-modal-content").height();
    let titleHeight = modal.find(".iwetc-modal-title").height();
    if (modal.find(".iwetc-modal-footer").length > 0) {
        footerHeight = modal.find(".iwetc-modal-footer").height() + 10;
    }
    let height = parseInt(contentHeight) - parseInt(titleHeight);
    if (modal.find('.iwetc-modal-top-search').length > 0) {
        height -= parseInt(modal.find('.iwetc-modal-top-search').height() + 40);
    }

    modal.find(".iwetc-modal-content").css({
        "height": contentHeight + footerHeight
    });
    modal.find(".iwetc-modal-body").css({
        "height": height
    });
    modal.find(".iwetc-modal-box").css({
        "height": contentHeight + footerHeight
    });
}

function iwetcCloseModal() {
    // fix conflict with "Woo Invoice Pro" plugin
    jQuery('body').removeClass('_winvoice-modal-open');
    jQuery('._winvoice-modal-backdrop').remove();

    let lastModalOpened = jQuery('#iwetc-last-modal-opened');
    let modal = jQuery(lastModalOpened.val());

    if (lastModalOpened.val() !== '') {
        if (lastModalOpened.val() == '#iwetc-modal-email-preview') {
            // clear modal container
            modal.find('.iwetc-builder-preview-container').html('');
        }
        modal.find(' .iwetc-modal-box').fadeOut();
        modal.fadeOut();
        lastModalOpened.val('');
    } else {
        jQuery('.iwetc-modal-box').fadeOut();
        jQuery('.iwetc-modal').fadeOut();
    }

    setTimeout(function () {
        modal.find('.iwetc-modal-box').css({
            height: 'auto',
            "max-height": '80%'
        });
        modal.find('.iwetc-modal-body').css({
            height: 'auto',
            "max-height": '90%'
        });
        modal.find('.iwetc-modal-content').css({
            height: 'auto',
            "max-height": '92%'
        });
    }, 400);
}
