<?php

namespace iwetcl\classes\controllers;

use iwetcl\classes\bootstrap\IWETCL_Verification;
use iwetcl\classes\repositories\Flush_Message;

class Activation_Controller
{
    public function __construct()
    {
        add_action('admin_enqueue_scripts', [$this, 'load_assets']);
    }

    public function index()
    {
        $is_active = IWETCL_Verification::is_active();
        $activation_skipped = IWETCL_Verification::skipped();

        $flush_message_repository = new Flush_Message();
        $flush_message = $flush_message_repository->get();

        include_once IWETCL_VIEWS_DIR . "activation/main.php";
    }

    public function load_assets()
    {
        if (!empty($_GET['page']) && $_GET['page'] == 'iwetc_activation') {
            // css
            wp_enqueue_style('iwetc-reset', IWETCL_CSS_URL . 'common/reset.css', [], IWETCL_VERSION);
            wp_enqueue_style('iwetc-sweetalert', IWETCL_CSS_URL . 'common/sweetalert.css', [], IWETCL_VERSION);
            wp_enqueue_style('iwetc-common', IWETCL_CSS_URL . 'common/style.css', [], IWETCL_VERSION);
            wp_enqueue_style('iwetc-main', IWETCL_CSS_URL . 'activation/style.css', [], IWETCL_VERSION);

            // js
            wp_enqueue_script('iwetc-sweetalert', IWETCL_JS_URL . 'common/sweetalert.min.js', [], IWETCL_VERSION);
            wp_enqueue_script('iwetc-main', IWETCL_JS_URL . 'activation/main.js', ['jquery'], IWETCL_VERSION);
        }
    }
}
