<?php

namespace iwetcl\classes\repositories\builder;

class Email_Template
{
    private static $instance;

    public static function get_instance()
    {
        if (is_null(self::$instance)) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    private function __construct()
    {
        // 
    }

    public function get_email_by_type($type)
    {
        global $wpdb;

        $email = [
            'subject' => '',
            'structure' => '',
            'custom_css' => '',
            'direction' => ''
        ];

        $post = $wpdb->get_results($wpdb->prepare(
            "SELECT posts.ID as post_id, posts.post_title as email_subject FROM {$wpdb->posts} as posts 
            LEFT JOIN {$wpdb->prefix}postmeta as postmeta ON (posts.ID = postmeta.post_id) 
            LEFT JOIN {$wpdb->prefix}postmeta as postmeta2 ON (posts.ID = postmeta2.post_id) 
            WHERE postmeta.meta_key = 'iwetc_email_type' AND postmeta.meta_value = '%s'
            AND postmeta2.meta_key = 'iwetc_template_enable' AND postmeta2.meta_value = 'true'
            GROUP BY posts.ID 
            ORDER BY posts.ID 
            DESC LIMIT 1",
            sanitize_text_field($type)
        ), ARRAY_A);

        if (!empty($post[0]['post_id'])) {
            $postmeta = get_post_meta(intval($post[0]['post_id']));
            $email['subject'] = (!empty($post[0]['email_subject'])) ? sanitize_text_field($post[0]['email_subject']) : '';
            $email['structure'] = (!empty($postmeta['iwetc_email_structure'][0])) ? $postmeta['iwetc_email_structure'][0] : '';
            $email['custom_css'] = (!empty($postmeta['iwetc_custom_css'][0])) ? $postmeta['iwetc_custom_css'][0] : '';
            $email['direction'] = (!empty($postmeta['iwetc_direction'][0])) ? $postmeta['iwetc_direction'][0] : '';
        }

        return $email;
    }
}
