<?php

namespace iwetcl\classes\repositories\builder;

class Email_Type
{
    private static $instance;

    private $email_types;
    private $grouped_email_types;

    public static function get_instance()
    {
        if (is_null(self::$instance)) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    private function __construct()
    {
        $this->email_types['default'] = __('Default template');
        $this->grouped_email_types[] = [
            'default' => __('Default template')
        ];

        $woocommerce_emails = wc()->mailer()->get_emails();
        if (!empty($woocommerce_emails) && is_array($woocommerce_emails)) {
            foreach ($woocommerce_emails as $email) {
                $group = (!empty($email->recipient)) ? 'admin' : 'customer';
                $this->grouped_email_types[$group][$email->id] = $email->title;
                $this->email_types[$email->id] = $email->title;
            }
        }
    }

    public function get_email_types()
    {
        return $this->email_types;
    }

    public function get_grouped_email_types()
    {
        return $this->grouped_email_types;
    }

    public function get_type($type)
    {
        $types = $this->get_email_types();
        return (!empty($types[$type])) ? sanitize_text_field($types[$type]) : null;
    }

    public function get_email_recipient()
    {
        $emails = wc()->mailer()->get_emails();
        $email_recipient = wp_list_pluck($emails, 'recipient', 'id');
        $email_recipient['customer_partially_refunded_order'] = '';
        $email_recipient['customer_invoice_pending'] = '';

        return $email_recipient;
    }
}
