<?php

namespace iwetcl\classes\templates\customer_new_account;

use iwetcl\classes\templates\Template_Interface;

class Customer_New_Account implements Template_Interface
{
    private static $instance;

    public static function get_instance()
    {
        if (is_null(self::$instance)) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    private function __construct()
    {
    }

    public function get_templates()
    {
        return [
            'default' => [
                'label' => __('New Account - Default', 'ithemeland-woocommerce-email-template-customizer-lite'),
                'thumbnail' => IWETCL_IMAGES_URL . 'templates/customer_new_account_default.jpg',
                'structure' => str_replace('IWETCL_IMAGES_URL', IWETCL_IMAGES_URL, file_get_contents(__DIR__ . DIRECTORY_SEPARATOR  . 'default.json')),
            ],
            'demo_1' => [
                'label' => __('New Account - Demo 1', 'ithemeland-woocommerce-email-template-customizer-lite'),
                'thumbnail' => IWETCL_IMAGES_URL . 'templates/customer_new_account_demo_1.jpg',
                'pro' => true,
                'structure' => '',
            ],
            'demo_2' => [
                'label' => __('New Account - Demo 2', 'ithemeland-woocommerce-email-template-customizer-lite'),
                'thumbnail' => IWETCL_IMAGES_URL . 'templates/customer_new_account_demo_2.jpg',
                'pro' => true,
                'structure' => '',
            ],
            'demo_3' => [
                'label' => __('New Account - Demo 3', 'ithemeland-woocommerce-email-template-customizer-lite'),
                'thumbnail' => IWETCL_IMAGES_URL . 'templates/customer_new_account_demo_3.jpg',
                'pro' => true,
                'structure' => '',
            ],
            'demo_4' => [
                'label' => __('New Account - Demo 4', 'ithemeland-woocommerce-email-template-customizer-lite'),
                'thumbnail' => IWETCL_IMAGES_URL . 'templates/customer_new_account_demo_4.jpg',
                'pro' => true,
                'structure' => '',
            ],
            'demo_5' => [
                'label' => __('New Account - Demo 5', 'ithemeland-woocommerce-email-template-customizer-lite'),
                'thumbnail' => IWETCL_IMAGES_URL . 'templates/customer_new_account_demo_5.jpg',
                'pro' => true,
                'structure' => '',
            ],
        ];
    }
}
