<?php
/*
Plugin Name: Email Template Customizer for WooCommerce
Plugin URI: http://ithemelandco.com/plugins/ithemeland-woocommerce-email-template-customizer/
Description: Drag-and-Drop email template plugin for creating email messages of any complexity fast, with no limits and no coding skills
Author: iThemelandco
Tested up to: WP 5.3
Requires PHP: 7.0
Tags: woocommerce
Text Domain: ithemeland-woocommerce-email-template-customizer-lite
Domain Path: /languages
Version: 1.1.0
Author URI: https://www.ithemelandco.com
*/

defined('ABSPATH') || exit();

if (defined('IWETCL_PRO')) {
    return;
}

require_once __DIR__ . '/vendor/autoload.php';

define('IWETCL_NAME', 'ithemeland-woocommerce-email-template-customizer-lite');
define('IWETCL_LABEL', 'Email Template Customizer for WooCommerce');
define('IWETCL_DIR', trailingslashit(plugin_dir_path(__FILE__)));
define('IWETCL_MAIN_PAGE', admin_url('edit.php?post_type=iwetc_emails'));
define('IWETCL_ACTIVATION_PAGE', admin_url('edit.php?post_type=iwetc_emails&page=iwetc_activation'));
define('IWETCL_ACTIVATION_SUB_PAGE', IWETCL_MAIN_PAGE . '&page=iwetc_activation');
define('IWETCL_URL', trailingslashit(plugin_dir_url(__FILE__)));
define('IWETCL_VIEWS_DIR', trailingslashit(IWETCL_DIR . 'views'));
define('IWETCL_LANGUAGES_DIR', dirname(plugin_basename(__FILE__)) . '/languages/');
define('IWETCL_ASSETS_DIR', trailingslashit(IWETCL_DIR . 'assets'));
define('IWETCL_ASSETS_URL', trailingslashit(IWETCL_URL . 'assets'));
define('IWETCL_CSS_URL', trailingslashit(IWETCL_ASSETS_URL . 'css'));
define('IWETCL_IMAGES_URL', trailingslashit(IWETCL_ASSETS_URL . 'images'));
define('IWETCL_JS_URL', trailingslashit(IWETCL_ASSETS_URL . 'js'));
define('IWETCL_WP_TESTED', '5.5.1');
define('IWETCL_WP_REQUIRE', '5.0.0');
define('IWETCL_VERSION', '1.1.0');

register_activation_hook(__FILE__, ['iwetcl\classes\bootstrap\IWETCL', 'activate']);
register_deactivation_hook(__FILE__, ['iwetcl\classes\bootstrap\IWETCL', 'deactivate']);

add_action('init', ['iwetcl\classes\bootstrap\IWETCL', 'iwetcl_wp_init']);

add_action('plugins_loaded', function () {
    if (!class_exists('WooCommerce')) {
        iwetcl\classes\bootstrap\IWETCL::iwetcl_woocommerce_required();
    } else {
        iwetcl\classes\bootstrap\IWETCL::init();
    }
}, PHP_INT_MAX);
