<?php $industries = iwetcl\classes\helpers\Industry_Helper::get_industries(); ?>

<div id="iwetc-body">
    <div class="iwetc-dashboard-body">
        <div id="iwetc-activation">
            <?php if (isset($is_active) && $is_active === true && $activation_skipped !== true) : ?>
                <div class="iwetc-wrap">
                    <div class="iwetc-tab-middle-content">
                        <div id="iwetc-activation-info">
                            <strong><?php _e("Congratulations, Your plugin is activated successfully. Let's Go!", 'ithemeland-woocommerce-email-template-customizer-lite') ?></strong>
                        </div>
                    </div>
                </div>
            <?php else : ?>
                <div class="iwetc-wrap iwetc-activation-form">
                    <div class="iwetc-tab-middle-content">
                        <?php if (!empty($flush_message) && is_array($flush_message)) : ?>
                            <div class="iwetc-alert <?php echo ($flush_message['message'] == "Success !") ? "iwetc-alert-success" : "iwetc-alert-danger"; ?>">
                                <span><?php echo esc_html($flush_message['message']); ?></span>
                            </div>
                        <?php endif; ?>
                        <form action="<?php echo esc_url(admin_url('admin-post.php')); ?>" method="post" id="iwetc-activation-form">
                            <h3 class="iwetc-activation-top-alert">Fill the below form to get the latest updates' news and <strong style="text-decoration: underline;">Special Offers(Discount)</strong>, Otherwise, Skip it!</h3>
                            <input type="hidden" name="action" value="iwetc_activation_plugin">
                            <div class="iwetc-activation-field">
                                <label for="iwetc-activation-email"><?php _e('Email', 'ithemeland-woocommerce-email-template-customizer-lite'); ?> </label>
                                <input type="email" name="email" placeholder="Email ..." id="iwetc-activation-email" required>
                            </div>
                            <div class="iwetc-activation-field">
                                <label for="iwetc-activation-industry"><?php _e('What is your industry?', 'ithemeland-woocommerce-email-template-customizer-lite'); ?> </label>
                                <select name="industry" id="iwetc-activation-industry" required>
                                    <option value=""><?php _e('Select', 'ithemeland-woocommerce-email-template-customizer-lite'); ?></option>
                                    <?php
                                    if (!empty($industries)) :
                                        foreach ($industries as $industry_key => $industry_label) :
                                    ?>
                                            <option value="<?php echo esc_attr($industry_key); ?>"><?php echo esc_attr($industry_label); ?></option>
                                    <?php
                                        endforeach;
                                    endif
                                    ?>
                                </select>
                            </div>
                            <input type="hidden" name="activation_type" id="iwetc-activation-type" value="">
                            <button type="button" id="iwetc-activation-activate" class="iwetc-button iwetc-button-lg iwetc-button-blue" value="1"><?php _e('Activate', 'ithemeland-woocommerce-email-template-customizer-lite'); ?></button>
                            <button type="button" id="iwetc-activation-skip" class="iwetc-button iwetc-button-lg iwetc-button-gray" style="float: left;" value="skip"><?php _e('Skip', 'ithemeland-woocommerce-email-template-customizer-lite'); ?></button>
                        </form>
                    </div>
                </div>
            <?php endif; ?>
        </div>
    </div>
</div>