<?php
if (!($order instanceof \WC_Order)) {
    $order = new \WC_Order();
    $order->set_total(65);
    $order->set_discount_total(5);
    $order->set_shipping_total(0.3);
}

$left_style = (!empty($children_attributes['order_subtotal_subtotal_text']['style'])) ? $children_attributes['order_subtotal_subtotal_text']['style'] : 'text-align: left;';
$right_style = (!empty($children_attributes['order_subtotal_price']['style'])) ? $children_attributes['order_subtotal_price']['style'] : 'text-align: right;';

?>
<table style="width: 100%; border-spacing: 0; border-collapse: collapse;">
    <tbody>
        <?php if (!empty($order->get_total())) : ?>
            <tr>
                <td style="<?php echo esc_attr($left_style); ?>"><?php echo esc_html($translate['subtotal']); ?></td>
                <td style="<?php echo esc_attr($right_style); ?>"><?php echo (!empty($order->get_total())) ? wc_price($order->get_total()) : ''; ?></td>
            </tr>
        <?php endif; ?>
        <?php if (!empty($order->get_discount_total())) : ?>
            <tr>
                <td style="<?php echo esc_attr($left_style); ?>"><?php echo esc_html($translate['discount']); ?></td>
                <td style="<?php echo esc_attr($right_style); ?>"><?php echo (!empty($order->get_discount_total())) ? wc_price($order->get_discount_total()) : ''; ?></td>
            </tr>
        <?php endif; ?>
        <?php if (!empty($order->get_shipping_total())) : ?>
            <tr>
                <td style="<?php echo esc_attr($left_style); ?>"><?php echo esc_html($translate['shipping']); ?></td>
                <td style="<?php echo esc_attr($right_style); ?>"><?php echo (!empty($order->get_shipping_total())) ? wc_price($order->get_shipping_total()) : ''; ?></td>
            </tr>
        <?php endif; ?>
        <?php if (!empty($order->get_total_refunded())) : ?>
            <tr>
                <td style="<?php echo esc_attr($left_style); ?>"><?php echo esc_html($translate['order_fully_refunded']); ?></td>
                <td style="<?php echo esc_attr($right_style); ?>"><?php echo (!empty($order->get_total_refunded())) ? wc_price($order->get_total_refunded()) : ''; ?></td>
            </tr>
        <?php endif; ?>
        <?php if (!empty($order->get_total_refunded())) : ?>
            <tr>
                <td style="<?php echo esc_attr($left_style); ?>"><?php echo esc_html($translate['refunded']); ?></td>
                <td style="<?php echo esc_attr($right_style); ?>"><?php echo (!empty($order->get_total_refunded())) ? wc_price($order->get_total_refunded()) : ''; ?></td>
            </tr>
        <?php endif; ?>
    </tbody>
</table>